const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Maquinas_atividadeDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const maquinas_atividade = await db.maquinas_atividade.create(
      {
        id: data.id || undefined,

        quantidade_prevista: data.quantidade_prevista || null,
        horas_utilizacao_previstas: data.horas_utilizacao_previstas || null,
        comentarios: data.comentarios || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await maquinas_atividade.setEstrutura(data.estrutura || null, {
      transaction,
    });

    await maquinas_atividade.setClientes(data.clientes || null, {
      transaction,
    });

    return maquinas_atividade;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const maquinas_atividadeData = data.map((item, index) => ({
      id: item.id || undefined,

      quantidade_prevista: item.quantidade_prevista || null,
      horas_utilizacao_previstas: item.horas_utilizacao_previstas || null,
      comentarios: item.comentarios || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const maquinas_atividade = await db.maquinas_atividade.bulkCreate(
      maquinas_atividadeData,
      { transaction },
    );

    // For each item created, replace relation files

    return maquinas_atividade;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const maquinas_atividade = await db.maquinas_atividade.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.quantidade_prevista !== undefined)
      updatePayload.quantidade_prevista = data.quantidade_prevista;

    if (data.horas_utilizacao_previstas !== undefined)
      updatePayload.horas_utilizacao_previstas =
        data.horas_utilizacao_previstas;

    if (data.comentarios !== undefined)
      updatePayload.comentarios = data.comentarios;

    updatePayload.updatedById = currentUser.id;

    await maquinas_atividade.update(updatePayload, { transaction });

    if (data.estrutura !== undefined) {
      await maquinas_atividade.setEstrutura(
        data.estrutura,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await maquinas_atividade.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return maquinas_atividade;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const maquinas_atividade = await db.maquinas_atividade.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of maquinas_atividade) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of maquinas_atividade) {
        await record.destroy({ transaction });
      }
    });

    return maquinas_atividade;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const maquinas_atividade = await db.maquinas_atividade.findByPk(
      id,
      options,
    );

    await maquinas_atividade.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await maquinas_atividade.destroy({
      transaction,
    });

    return maquinas_atividade;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const maquinas_atividade = await db.maquinas_atividade.findOne(
      { where },
      { transaction },
    );

    if (!maquinas_atividade) {
      return maquinas_atividade;
    }

    const output = maquinas_atividade.get({ plain: true });

    output.estrutura = await maquinas_atividade.getEstrutura({
      transaction,
    });

    output.clientes = await maquinas_atividade.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.estrutura_projeto,
        as: 'estrutura',

        where: filter.estrutura
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.estrutura
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  etapa: {
                    [Op.or]: filter.estrutura
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.comentarios) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'maquinas_atividade',
            'comentarios',
            filter.comentarios,
          ),
        };
      }

      if (filter.quantidade_previstaRange) {
        const [start, end] = filter.quantidade_previstaRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            quantidade_prevista: {
              ...where.quantidade_prevista,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            quantidade_prevista: {
              ...where.quantidade_prevista,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.horas_utilizacao_previstasRange) {
        const [start, end] = filter.horas_utilizacao_previstasRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            horas_utilizacao_previstas: {
              ...where.horas_utilizacao_previstas,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            horas_utilizacao_previstas: {
              ...where.horas_utilizacao_previstas,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.maquinas_atividade.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('maquinas_atividade', 'quantidade_prevista', query),
        ],
      };
    }

    const records = await db.maquinas_atividade.findAll({
      attributes: ['id', 'quantidade_prevista'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['quantidade_prevista', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.quantidade_prevista,
    }));
  }
};
